﻿# STM32L4R9I-DISCO Discovery board

## Overview

The 32L4R9IDISCOVERY Discovery kit is a complete demonstration and development platform for
STMicroelectronics Arm® Cortex®-M4 core-based STM32L4R9AI microcontroller.

Leveraging the innovative ultra-low-power oriented features, 640 Kbytes of embedded RAM, graphics performance (Chrom-ART Accelerator),
and DSI controller offered by the STM32L4R9AI, the 32L4R9IDISCOVERY Discovery kit enables users to easily prototype applications with
state-of-the-art energy efficiency, as well as stunning audio and graphics rendering with direct support for AMOLED DSI round LCD display.

For even more user-friendliness, the on-board ST-LINK/V2-1 debugger provides out-of-the-box programming and debugging capabilities.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um2271-discovery-kit-with-stm32l4r9ai-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32L4R9AI microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32l4r9ai.html)
- [STM32L4R9I-DISCO board](https://www.st.com/en/evaluation-tools/32l4r9idiscovery.html)
- [User manual](https://www.st.com/resource/en/user_manual/um2271-discovery-kit-with-stm32l4r9ai-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/32l4r9idiscovery.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/stm32l4r9i-disco_sch.zip)
